//+------------------------------------------------------------------+
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
#property indicator_chart_window
#property indicator_buffers 0
#property indicator_minimum 0
#property indicator_maximum 1


//
//
//
//
//

extern string             _                = "pairs and timeframes";
extern string             timeFrames       = "M1;M5;M15;M30;H1;H4;D1;W1;MN";
extern string             uniqueID         = "Volatility ratio dashboard";
extern int                VolPeriod        = 14;
extern int                Smooth           = 3;
extern ENUM_MA_METHOD     SmoothMethod     = MODE_LWMA;
extern double             LevelToCheckUp   = 3;
extern double             LevelToCheckDown = 1;
extern bool               LevelCheckAverage = false;
extern string             __               = "colors";
extern color              ColorUp          = DeepSkyBlue;
extern color              ColorNeutral     = Gray;
extern color              ColorDown        = PaleVioletRed;
extern color              ColorPrice       = CornflowerBlue;
extern color              ColorLabels      = Gray;
extern int                xPosition        = 500;
extern int                yPosition        = 500;


//
//
//
//
//

int    window;  
int    totalSymbols;
int    totalTimeFrames;
int    totalLabels;
int    aTimes[];
string aSymbol[1];
string sTimes[];
string labelNames;
string shortName;
string indicatorFileName;
double vol[];
double volavg[];
bool   calculate;
int    corner;


//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   corner     = 0;
   shortName  = uniqueID+" :";
   labelNames = shortName;
   indicatorFileName = WindowExpertName();
   calculate = (_=="calculate");
      if (calculate)
      {
         IndicatorBuffers(2);
            SetIndexBuffer(0,vol);
            SetIndexBuffer(1,volavg);
            return(0);
      }
      IndicatorShortName(shortName);
      aSymbol[0] = Symbol();

      //
      //
      //
      //
      //

      StringToUpper(timeFrames); timeFrames = StringTrimLeft(StringTrimRight(timeFrames));
      if (StringSubstr(timeFrames,StringLen(timeFrames),1) != ";")
                       timeFrames = StringConcatenate(timeFrames,";");

         //
         //
         //
         //
         //                                   
            
         int s = 0;
         int i = StringFind(timeFrames,";",s);
         int time;
            while (i > 0)
            {
               string current = StringSubstr(timeFrames,s,i-s);
               time           = stringToTimeFrame(current);
               if (time > 0) {
                     ArrayResize(sTimes,ArraySize(sTimes)+1);
                     ArrayResize(aTimes,ArraySize(aTimes)+1);
                                 sTimes[ArraySize(sTimes)-1] = timeFrameToString(time); 
                                 aTimes[ArraySize(aTimes)-1] = time; }
                                 s = i + 1;
                                     i = StringFind(timeFrames,";",s);
            }

      //
      //
      //
      //
      //

      totalTimeFrames = ArraySize(aTimes);
      totalSymbols    = ArraySize(aSymbol);
   return(0);
}

//
//
//
//
//

int deinit()
{
   string lookFor       = labelNames;
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
   return(0);
}


//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------

int start()
{
   int m,n;
   int i,k;

   //
   //
   //
   //
   //

   if (calculate)
   {
      int counted_bars=IndicatorCounted();
         if(counted_bars < 0) return(-1);
         if(counted_bars>0) counted_bars--;
            int limit = MathMin(Bars-counted_bars,Bars-1);
         for(i = limit; i >= 0; i--)
         {
            double range = MathMax(High[i],Close[i+1])-MathMin(Low[i],Close[i+1]);
            double atr   = iATR(NULL,0,VolPeriod,i+1);
               if (atr!=0)
                     vol[i] = range/atr;
               else  vol[i] = 0;                  
      }
      for(i = limit; i >= 0; i--) volavg[i] = iMAOnArray(vol,0,Smooth,0,SmoothMethod,i);
      return(0);   
   }
   
   //
   //
   //
   //
   //
   
   window      = 0;
   totalLabels = 0;
         for (i=0,m=xPosition; i < totalSymbols;    i++, m+=100)
         for (k=0,n=yPosition; k < totalTimeFrames; k++, n+=13)
               showSymbol(aSymbol[i],aTimes[k],sTimes[k],m,n);
   return(0);
}


//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
//
//
//
//
//

void showSymbol(string symbol, int timeFrame, string label, int xdistance, int ydistance)
{
   double price = iClose(symbol,0,0);
      if (ydistance==yPosition)
      {
         setObject(next(),symbol                                           ,xdistance-1 ,yPosition   ,ColorLabels,"Arial Bold",12,270);
         setObject(next(),DoubleToStr(price,MarketInfo(symbol,MODE_DIGITS)),xdistance-16,yPosition-20,ColorPrice ,"Arial Bold",12);
      }            

      //
      //
      //
      //
      //

      int bufferToCheck = 0; if (LevelCheckAverage) bufferToCheck = 1;
      double value = iCustom(symbol,timeFrame,indicatorFileName,"calculate","","",VolPeriod,Smooth,SmoothMethod,bufferToCheck,0);
      color theColor = ColorNeutral;
         if (value>LevelToCheckUp  ) theColor = ColorUp;
         if (value<LevelToCheckDown) theColor = ColorDown;
         setLabel(label,xdistance,ydistance,theColor);
}

//
//
//
//
//

string next() { totalLabels++; return(totalLabels); }  
void setLabel(string text,int x,int y, color theColor)
{
   if (theColor == ColorNeutral)
         string arrow = "";
   else         arrow = "l";    
   if (text!=" ") setObject(next(),text ,x+2 ,y,ColorLabels);
                  setObject(next(),arrow,x+35,y,theColor,"Wingdings",9);
}

//
//
//
//
//

void setObject(string name,string text,int x,int y,color theColor, string font = "Arial",int size=10,int angle=0)
{
   string labelName = StringConcatenate(labelNames,name);

   if (ObjectFind(labelName) == -1)
   {
      ObjectCreate(labelName,OBJ_LABEL,window,0,0);
      ObjectSet(labelName,OBJPROP_CORNER,corner);
      if (angle != 0)
         ObjectSet(labelName,OBJPROP_ANGLE,angle);
    }               
    ObjectSet(labelName,OBJPROP_XDISTANCE,x);
    ObjectSet(labelName,OBJPROP_YDISTANCE,y);
    ObjectSetText(labelName,text,size,font,theColor);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   StringToUpper(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(iTfTable[i]);
         return(_Period);
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}